История изменений
=================

## 2.x

### 2.9.0 == 2019.10.03

\* BPlot2D: исправлена работа на видеокартах GeForce.

\+ BPlot2Dt: клон BPlot2D, добавляющий переменную t (время) в шейдер.


### 2.8.4 == 2018.02.06

\+ BPlot2D: добавлены примеры 3 (нули системы уравнений, выделение цветом) и 4 (суперэллипсы, в общем-то подобие примера 1).


### 2.8.3 == 2017.02.13

\* SortVis: мелкие доработки, добавлен алгоритм sheap.

\* CPlot2D: мелкие доработки


### 2.8.2 == 2016.12.12 (unreleased)

\+ SortVis: добавлена поддержка нового события сортировки: "получения численного значения" (синий цвет)

\+ SortVis: добавлены сортировки на основе сортировки подсчётом: bucket, lsd4, lsd8, msd4, msd8

\+ SortVis: добавлена последовательность с нормальным распределением (9)


### 2.8.1 == 2016.12.06 (unreleased)

\+ SortVis: проверка корректности сортировки (помечает красным название алгоритма)

\+ SortVis: добавлены алгоритмы: inmerge, inmerge2, pquick, rquick, stquick, heap3, heap4, cis, cis14, cis16, cqs16, cims16

\+ SortVis: добавлена "волнообразная последовательность" (8)


### 2.8.0 == 2016.05.09 (unreleased)

\+ CPlot2D: асинхронное рисование графиков (на основе APlot2D), простой внешний интерфейс

\+ SortVis: добавлены некоторые варианты сортировок


### 2.7.0 == 2015.05.30 (unreleased)

\+ FIRFilter: FIR-фильтр, численно дифференцирующий сигнал


### 2.6.0 == 2015.05.02

\+ GLPrimitivesVB: аналог GLPrimitivesVA, использующий память GPU для размещения массива вершин

\+ Plasma: программная реализация билинейной интерполяции (кнопка 4)

\+ Plasma: симуляция процесса теплопереноса, визуализация карты температур посредством билинейной интерполяции (кнопка 5)


### 2.5.4 == 2015.03.18

\+ SortVis: дополняет название алгоритма сортировки номером в порядке её завершения на визуализации

\* SortVis: уменьшен объём потребляемой памяти, теперь не падает на нескольких тысячах элементов при использовании квадратичных сортировок (ранее 32-битной сборке могло не хватить штатных 2Гб на процесс)

\* Многочисленные переименования в коде


### 2.5.3 == 2014.10.25

\+ Plasma: добавлен тест быстродействия процессора

\* Collision3D: изменён способ генерирования сцены (теперь есть "солнце" + остальные шары получают касательные скорости)

\* APlot2D, BPlot2D, GLUPoly: изменён способ подгонки бокса под размеры окна (новый способ не приводит к неограниченному увеличению бокса)

\- BPlot2D: ошибка позиционирования осей на Intel iGPU


### 2.5.2 == 2014.10.16

\* BPlot2D: исправлена ошибка в шейдере, требуется версия OpenGL 2.1 или выше (было 2.0)

\+ BPlot2D: добавлены шейдеры 1.bplot2d.glsl.frag и 2.bplot2d.glsl.frag

\* BPlot2D: исправлены ошибки компиляции шейдеров на Intel HD 4600


### 2.5.1 == 2014.10.14

\+ BPlot2D: перезагрузка текущего шейдера при нажатии Enter или Space

\* BPlot2D: убрано окно консоли

\+ GLSLPlasma: перезагрузка текущего шейдера при нажатии Enter или Space


### 2.5.0 == 2014.10.12

\+ BPlot2D: визуализация двумерных индикаторных функций, заданных в шейдерах x.bplot2d.glsl.frag

\* GLSLPlasma: переименованы файлы шейдеров: x.glsl.frag -> x.glslplasma.glsl.frag

\* GLSLPlasma: исправлены ошибки компиляции шейдеров на Intel HD 4600


### 2.4.1 == 2014.08.28

\+ Теперь сферическую камеру можно перемещать по трём осям и переворачивать при повороте (AStarVis, Collision3D)

\+ Collision3D: задача реализовать компенсационное суммирование


### 2.4.0 == 2014.08.15

\+ APlot2D: рисование однопараметрических графиков на плоскости

\* GLUPoly: Prim2 извлечён из Mesh2.hpp/cpp в отдельный Prim2.hpp

\* GLUPoly: Prim2.hpp, CoordinateGrid2.hpp, TextDrawer.hpp вынесены в общий Include/avo


### 2.3.4 == 2014.08.10 (unreleased)

\+ GLUPoly: вывод координат видимой области и мыши

\+ GLUPoly: изменение масштаба колёсиком мыши


### 2.3.3 == 2014.08.08 (unreleased)

\- PencilPaleo: убран счётчик FPS (оставлен в Pencil), убрано окно консоли

\* GLUPoly: координатная сетка теперь формируется в виде отдельных примитивов (glBegin/glEnd больше не используются), которые пересчитываются при перемещении камеры, а не на каждом кадре (CoordinateGrid2.hpp); ряд мелких изменений в коде


### 2.3.2 == 2014.08.04

\* Snow2D: массив объектов вместо параллельных массивов

\- Zmeika: NumberPresenter и NumberPresenterDecrementable заменены на std::to\_string в целях упрощения кода, ряд других мелких изменений

\- GLM пока убрана из сборки


### 2.3.1 == 2014.07.30 (unreleased)

\* Snow2D: переделан на основе GLPrimitivesVA (issue #2)

\* SortVis: использует C++11 <random> вместо srand/rand

\* мелкие правки в других примерах (функция random вынесена в avo/Basics.hpp)


### 2.3.0 == 2014.07.29 (unreleased)

\+ GLPrimitivesVA: аналог GLPrimitives, использующий массивы вершин

\+ GLPrimitives: F10, F11, F12 переключают режим растеризации; мелкие правки


### 2.2.0 == 2014.07.26

\+ ColorClock: "часы"


### 2.1.0 == 2014.07.25 (unreleased)

\+ BasicFrame: каркас FreeGlut-приложения

\* Zmeika: больше нет окна консоли (см. source/winmain.c)


### 2.0.0 == 2014.06.30

(version promotion: 1.2.4 > 2.0.0)

\- поддержка компиляторов и IDE: Visual Studio 2012 исключена из поддерживаемых

! предполагается частичный переход на GLM для работы с векторами и матрицами

\* большее использование C++1y, множество мелких правок

\* исправлен недочёт, приводивший к низкой точности таймера (issue #1)

\* обновление используемой версии FreeGlut до 2.8.1

\* обновление используемой версии GLEW до 1.10.0

\* обновление и пополнение документации Doxygen к Zmeika (включено в сборку)



## 1.x

### 1.2.3 == 2014.04.13

\+ AstarVis: двунаправленный аналог A* (не гарантирует оптимальность решения!)

\+ AstarVis: выводит в консоль стоимости полученных путей

\* AstarVis: значительно увеличена максимальная доступная скорость визуализации

\+ SortVis: алгоритм merge4 (восходящая + предварительная вставками)


### 1.2.2 == 2014.04.11

\+ GLSLPlasma: 3.glsl.frag основанный на [реализации](https://github.com/ashima/webgl-noise) [шума Перлина](http://en.wikipedia.org/wiki/Perlin_noise)

\+ SortVis: добавлены алгоритмы сортировки stdheap и hybheap

\+ SortVis: выводит статистику по работе алгоритмов в консоль

\* SortVis: показывает названия алгоритмов на старте и прочие мелочи


### 1.2.1 == 2014.01.31

\+ Zmeika: добавлен экран ввода имени игрока после окончания игры (раньше вводилось через консоль)

\* Zmeika: мелкий фикс: телепортация головы змеи в кролика приводила к невозможности появления новых кроликов


### 1.2.0 == 2014.01.18

\+ PencilPaleo: в качестве отдельного проекта восстановлен вариант Pencil версии 0.10.3, так как Pencil стал слишком сложным

\* GLPrimitives: нажатие +/- добавляет/удаляет вершины

\* GLPrimitives: опции сглаживания


### 1.1.0 == 2013.12.29

\+ GLPrimitives: демонстрация различных геометрических примитивов OpenGL 1.x

\* большее использование C++11


### 1.0.0 == 2013.11.16

(version promotion: 0.12.3 > 1.0.0)

! поддержка компиляторов и IDE: Visual Studio 2010 исключена из поддерживаемых, Visual Studio 2013 добавлена в поддерживаемые

! все заголовочные файлы C++ получили расширение .hpp

\* все варианты сборок с SSE2 по умолчанию

\+ Plasma: можно изменять количество потоков аналогично Pencil

\* Collision3D: интегрирование движения шариков методом Velocity Verlet


## 0.x

### 0.12.2 == 2013.08.13

\* SortVis: исправлена старая ошибка в merge2

\* SortVis: однократный вызов clearColor на массив прямоугольников за кадр, вместо старой практики вызова clearColor перед применением каждого события, в результате можно наблюдать сортировки на значительно большей скорости, чем раньше

\* множество мелких правок в разных файлах, в том числе в документации к Zmeika


### 0.12.1 == 2013.08.11 (unreleased)

\+ Pencil: третья реализация автомата: поклеточное ("cellwise") суммирование

\+ Pencil: возможность изменять количество используемых OpenMP потоков исполнения "на ходу" (кнопки [, ])

\* AstarVis: список соседей в TerrainGraph теперь является BoundedArray (см. avo/BoundedArray.hpp) вместо vector

\* множество мелких правок в разных файлах, в том числе исправление некоторых ошибок


### 0.12.0 == 2013.05.04

\+ GLUPoly: демонстрация использования GLU для триангуляции многоугольников

\+ Collision3D: добавлен механизм разведения шаров из Collision2D


### 0.11.1 == 2013.05.02

\+ Zmeika: добавлена автоматически сгенерированная документация (см. Zmeika\\html\\index.html)

\+ Zmeika: автоподгонка размеров и позиционирование окна

\* Zmeika: исправлен ряд мелких ошибок

\+ Zmeika: задание: добавить препятствия


### 0.11.0 == 2013.04.30

\+ Zmeika: простенькая игра "Змейка"

\+ GLSLPlasma: добавлен шейдер 2.glsl.frag (множество Мандельброта)

\+ GLSLPlasma: нажатие T сбрасывает время шейдера в 0

\* Collision2D: другой механизм разведения столкнувшихся шариков, больше нет эффекта "туннелирования"


### 0.10.5 == 2013.04.05

\* Pencil: исправлены некоторые ошибки; схема вычисления сумм (клеточный автомат) несколько изменена с целью уменьшения дублирующегося кода (скорость работы практически не изменилась)


### 0.10.4 == 2013.04.02

\* Pencil: переписан алгоритм игры Жизнь (оптимизация + простое распараллеливание средствами OpenMP), выполнен в двух вариантах: базовом и SSE3


### 0.10.3 == 2013.03.12

\+ SortVis: пауза по P, названия алгоритмов по T, выводит список всех поддерживаемых названий алгоритмов на старте


### 0.10.2 == 2013.03.04

\+ GLSLPlasma: цифровые клавиши переключают пиксельные шейдеры (файлы с пиксельными шейдерами имеют названия вида *d*.glsl.frag, где *d* -- цифра)

\+ SortVis: алгоритмы *merge2* и *merge3* (варианты восходящей сортировки слияниями)


### 0.10.1 == 2013.02.26

\* GLSLPlasma: шейдер приведён к спецификации GLSL 1.10 (OpenGL 2.0)

\* SortVis: сортировка вставками теперь не производит лишних присваиваний на отсортированных последовательностях


### 0.10.0 == 2013.02.25

\+ GLSLPlasma: эффект плазмы, реализованный в виде пиксельного шейдера


### 0.9.4 == 2013.02.19

\+ Задания ("TASK") в Pixels, Snow2D, Collision2D, Plasma, Pencil, SortVis


### 0.9.3 == 2013.02.07

\+ SortVis: различные генераторы последовательностей, алгоритмы *treeSort*, *treeSortBalanced*


### 0.9.2 == 2013.01.29

! общие файлы в include/source помещены в папку avo и включаются как <avo/somefile.h>

\* Pencil: добавлен вызов black\_canvas() в начале (т.к. pixels был 0 в сборке под MSVC2010 при первой перерисовке)

\* SortVis: \+GLUT\_MULTISAMPLE

\* Plasma


### 0.9.1 == 2013.01.25

Первая "полная" сборка.

\+ Manipulator, Plasma, SortVis, AStarVis.


### 0.5.0 == 2013.01.17

Первая сборка, выложенная в репозиторий: Collision2D, Collision3D, Pixels, Pencil, Snow2D.


# Легенда

! существенное структурное изменение

\* мелкие правки

\+ существенное дополнение

\- удаление
